/***************************************************************************
 *   Copyright (C) 2005-2007 Stefan Schwarzer, Jens Schneider,             *
 *                           Matthias Hardt, Guido Madaus                  *
 *                                                                         *
 *   Copyright (C) 2007-2008 Berlinux Solutions GbR                        *
 *                           Stefan Schwarzer & Guido Madaus               *
 *                                                                         *
 *   Authors:                                                              *
 *      Stefan Schwarzer <SSchwarzer@berlinux-solutions.de>,               *
 *      Matthias Hardt   <MHardt@berlinux-solutions.de>,                   *
 *      Jens Schneider   <pupeider@gmx.de>                                 *
 *      Guido Madaus     <GMadaus@berlinux-solutions.de>                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
 * mmsinbutkeys.cpp
 *
 *  Created on: 28.10.2008
 *      Author: sxs
 */

#include "mmsinput/mmskeymap.h"

std::map<MMSKeySymbol, std::string> MMSKeyMap::keymap;
std::map<std::string,MMSKeySymbol> MMSKeyMap::namemap;


MMSKeyMap::MMSKeyMap() {
	if(keymap.empty()) {
		keymap.insert(std::make_pair(MMSKEY_UNKNOWN,"UNKNOWN"));
		keymap.insert(std::make_pair(MMSKEY_BACKSPACE,"BACKSPACE"));
		keymap.insert(std::make_pair(MMSKEY_TAB,"TAB"));
		keymap.insert(std::make_pair(MMSKEY_RETURN,"RETURN"));
		keymap.insert(std::make_pair(MMSKEY_CANCEL,"CANCEL"));
		keymap.insert(std::make_pair(MMSKEY_ESCAPE,"ESCAPE"));
		keymap.insert(std::make_pair(MMSKEY_SPACE,"SPACE"));
		keymap.insert(std::make_pair(MMSKEY_EXCLAMATION_MARK,"EXCLAMATION_MARK"));
		keymap.insert(std::make_pair(MMSKEY_QUOTATION,"QUOTATION"));
		keymap.insert(std::make_pair(MMSKEY_NUMBER_SIGN,"NUMBER_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_DOLLAR_SIGN,"DOLLAR_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_PERCENT_SIGN,"PERCENT_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_AMPERSAND,"AMPERSAND"));
		keymap.insert(std::make_pair(MMSKEY_APOSTROPHE,"APOSTROPHE"));
		keymap.insert(std::make_pair(MMSKEY_PARENTHESIS_LEFT,"PARENTHESIS_LEFT"));
		keymap.insert(std::make_pair(MMSKEY_PARENTHESIS_RIGHT,"PARENTHESIS_RIGHT"));
		keymap.insert(std::make_pair(MMSKEY_ASTERISK,"ASTERISK"));
		keymap.insert(std::make_pair(MMSKEY_PLUS_SIGN,"PLUS_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_COMMA,"COMMA"));
		keymap.insert(std::make_pair(MMSKEY_MINUS_SIGN,"MINUS_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_PERIOD,"PERIOD"));
		keymap.insert(std::make_pair(MMSKEY_SLASH,"SLASH"));
		keymap.insert(std::make_pair(MMSKEY_0,"0"));
		keymap.insert(std::make_pair(MMSKEY_1,"1"));
		keymap.insert(std::make_pair(MMSKEY_2,"2"));
		keymap.insert(std::make_pair(MMSKEY_3,"3"));
		keymap.insert(std::make_pair(MMSKEY_4,"4"));
		keymap.insert(std::make_pair(MMSKEY_5,"5"));
		keymap.insert(std::make_pair(MMSKEY_6,"6"));
		keymap.insert(std::make_pair(MMSKEY_7,"7"));
		keymap.insert(std::make_pair(MMSKEY_8,"8"));
		keymap.insert(std::make_pair(MMSKEY_9,"9"));
		keymap.insert(std::make_pair(MMSKEY_COLON,"COLON"));
		keymap.insert(std::make_pair(MMSKEY_SEMICOLON,"SEMICOLON"));
		keymap.insert(std::make_pair(MMSKEY_LESS_THAN_SIGN,"LESS_THAN_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_EQUALS_SIGN,"EQUALS_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_GREATER_THAN_SIGN,"GREATER_THAN_SIGN"));
		keymap.insert(std::make_pair(MMSKEY_QUESTION_MARK,"QUESTION_MARK"));
		keymap.insert(std::make_pair(MMSKEY_AT,"AT"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_A,"CAPITAL_A"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_B,"CAPITAL_B"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_C,"CAPITAL_C"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_D,"CAPITAL_D"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_E,"CAPITAL_E"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_F,"CAPITAL_F"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_G,"CAPITAL_G"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_H,"CAPITAL_H"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_I,"CAPITAL_I"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_J,"CAPITAL_J"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_K,"CAPITAL_K"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_L,"CAPITAL_L"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_M,"CAPITAL_M"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_N,"CAPITAL_N"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_O,"CAPITAL_O"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_P,"CAPITAL_P"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_Q,"CAPITAL_Q"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_R,"CAPITAL_R"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_S,"CAPITAL_S"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_T,"CAPITAL_T"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_U,"CAPITAL_U"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_V,"CAPITAL_V"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_W,"CAPITAL_W"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_X,"CAPITAL_X"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_Y,"CAPITAL_Y"));
		keymap.insert(std::make_pair(MMSKEY_CAPITAL_Z,"CAPITAL_Z"));
		keymap.insert(std::make_pair(MMSKEY_SQUARE_BRACKET_LEFT,"SQUARE_BRACKET_LEFT"));
		keymap.insert(std::make_pair(MMSKEY_BACKSLASH,"BACKSLASH"));
		keymap.insert(std::make_pair(MMSKEY_SQUARE_BRACKET_RIGHT,"SQUARE_BRACKET_RIGHT"));
		keymap.insert(std::make_pair(MMSKEY_CIRCUMFLEX_ACCENT,"CIRCUMFLEX_ACCENT"));
		keymap.insert(std::make_pair(MMSKEY_UNDERSCORE,"UNDERSCORE"));
		keymap.insert(std::make_pair(MMSKEY_GRAVE_ACCENT,"GRAVE_ACCENT"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_A,"SMALL_A"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_B,"SMALL_B"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_C,"SMALL_C"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_D,"SMALL_D"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_E,"SMALL_E"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_F,"SMALL_F"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_G,"SMALL_G"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_H,"SMALL_H"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_I,"SMALL_I"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_J,"SMALL_J"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_K,"SMALL_K"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_L,"SMALL_L"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_M,"SMALL_M"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_N,"SMALL_N"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_O,"SMALL_O"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_P,"SMALL_P"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_Q,"SMALL_Q"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_R,"SMALL_R"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_S,"SMALL_S"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_T,"SMALL_T"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_U,"SMALL_U"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_V,"SMALL_V"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_W,"SMALL_W"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_X,"SMALL_X"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_Y,"SMALL_Y"));
		keymap.insert(std::make_pair(MMSKEY_SMALL_Z,"SMALL_Z"));
		keymap.insert(std::make_pair(MMSKEY_CURLY_BRACKET_LEFT,"CURLY_BRACKET_LEFT"));
		keymap.insert(std::make_pair(MMSKEY_VERTICAL_BAR,"VERTICAL_BAR"));
		keymap.insert(std::make_pair(MMSKEY_CURLY_BRACKET_RIGHT,"CURLY_BRACKET_RIGHT"));
		keymap.insert(std::make_pair(MMSKEY_TILDE,"TILDE"));
		keymap.insert(std::make_pair(MMSKEY_DELETE,"DELETE"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_LEFT,"CURSOR_LEFT"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_RIGHT,"CURSOR_RIGHT"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_UP,"CURSOR_UP"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_DOWN,"CURSOR_DOWN"));
		keymap.insert(std::make_pair(MMSKEY_INSERT,"INSERT"));
		keymap.insert(std::make_pair(MMSKEY_HOME,"HOME"));
		keymap.insert(std::make_pair(MMSKEY_END,"END"));
		keymap.insert(std::make_pair(MMSKEY_PAGE_UP,"PAGE_UP"));
		keymap.insert(std::make_pair(MMSKEY_PAGE_DOWN,"PAGE_DOWN"));
		keymap.insert(std::make_pair(MMSKEY_PRINT,"PRINT"));
		keymap.insert(std::make_pair(MMSKEY_PAUSE,"PAUSE"));
		keymap.insert(std::make_pair(MMSKEY_OK,"OK"));
		keymap.insert(std::make_pair(MMSKEY_SELECT,"SELECT"));
		keymap.insert(std::make_pair(MMSKEY_GOTO,"GOTO"));
		keymap.insert(std::make_pair(MMSKEY_CLEAR,"CLEAR"));
		keymap.insert(std::make_pair(MMSKEY_POWER,"POWER"));
		keymap.insert(std::make_pair(MMSKEY_POWER2,"POWER2"));
		keymap.insert(std::make_pair(MMSKEY_OPTION,"OPTION"));
		keymap.insert(std::make_pair(MMSKEY_MENU,"MENU"));
		keymap.insert(std::make_pair(MMSKEY_HELP,"HELP"));
		keymap.insert(std::make_pair(MMSKEY_INFO,"INFO"));
		keymap.insert(std::make_pair(MMSKEY_TIME,"TIME"));
		keymap.insert(std::make_pair(MMSKEY_VENDOR,"VENDOR"));
		keymap.insert(std::make_pair(MMSKEY_ARCHIVE,"ARCHIVE"));
		keymap.insert(std::make_pair(MMSKEY_PROGRAM,"PROGRAM"));
		keymap.insert(std::make_pair(MMSKEY_CHANNEL,"CHANNEL"));
		keymap.insert(std::make_pair(MMSKEY_FAVORITES,"FAVORITES"));
		keymap.insert(std::make_pair(MMSKEY_EPG,"EPG"));
		keymap.insert(std::make_pair(MMSKEY_PVR,"PVR"));
		keymap.insert(std::make_pair(MMSKEY_MHP,"MHP"));
		keymap.insert(std::make_pair(MMSKEY_LANGUAGE,"LANGUAGE"));
		keymap.insert(std::make_pair(MMSKEY_TITLE,"TITLE"));
		keymap.insert(std::make_pair(MMSKEY_SUBTITLE,"SUBTITLE"));
		keymap.insert(std::make_pair(MMSKEY_ANGLE,"ANGLE"));
		keymap.insert(std::make_pair(MMSKEY_ZOOM,"ZOOM"));
		keymap.insert(std::make_pair(MMSKEY_MODE,"MODE"));
		keymap.insert(std::make_pair(MMSKEY_KEYBOARD,"KEYBOARD"));
		keymap.insert(std::make_pair(MMSKEY_PC,"PC"));
		keymap.insert(std::make_pair(MMSKEY_SCREEN,"SCREEN"));
		keymap.insert(std::make_pair(MMSKEY_TV,"TV"));
		keymap.insert(std::make_pair(MMSKEY_TV2,"TV2"));
		keymap.insert(std::make_pair(MMSKEY_VCR,"VCR"));
		keymap.insert(std::make_pair(MMSKEY_VCR2,"VCR2"));
		keymap.insert(std::make_pair(MMSKEY_SAT,"SAT"));
		keymap.insert(std::make_pair(MMSKEY_SAT2,"SAT2"));
		keymap.insert(std::make_pair(MMSKEY_CD,"CD"));
		keymap.insert(std::make_pair(MMSKEY_TAPE,"TAPE"));
		keymap.insert(std::make_pair(MMSKEY_RADIO,"RADIO"));
		keymap.insert(std::make_pair(MMSKEY_TUNER,"TUNER"));
		keymap.insert(std::make_pair(MMSKEY_PLAYER,"PLAYER"));
		keymap.insert(std::make_pair(MMSKEY_TEXT,"TEXT"));
		keymap.insert(std::make_pair(MMSKEY_DVD,"DVD"));
		keymap.insert(std::make_pair(MMSKEY_AUX,"AUX"));
		keymap.insert(std::make_pair(MMSKEY_MP3,"MP3"));
		keymap.insert(std::make_pair(MMSKEY_PHONE,"PHONE"));
		keymap.insert(std::make_pair(MMSKEY_AUDIO,"AUDIO"));
		keymap.insert(std::make_pair(MMSKEY_VIDEO,"VIDEO"));
		keymap.insert(std::make_pair(MMSKEY_INTERNET,"INTERNET"));
		keymap.insert(std::make_pair(MMSKEY_MAIL,"MAIL"));
		keymap.insert(std::make_pair(MMSKEY_NEWS,"NEWS"));
		keymap.insert(std::make_pair(MMSKEY_DIRECTORY,"DIRECTORY"));
		keymap.insert(std::make_pair(MMSKEY_LIST,"LIST"));
		keymap.insert(std::make_pair(MMSKEY_CALCULATOR,"CALCULATOR"));
		keymap.insert(std::make_pair(MMSKEY_MEMO,"MEMO"));
		keymap.insert(std::make_pair(MMSKEY_CALENDAR,"CALENDAR"));
		keymap.insert(std::make_pair(MMSKEY_EDITOR,"EDITOR"));
		keymap.insert(std::make_pair(MMSKEY_RED,"RED"));
		keymap.insert(std::make_pair(MMSKEY_GREEN,"GREEN"));
		keymap.insert(std::make_pair(MMSKEY_YELLOW,"YELLOW"));
		keymap.insert(std::make_pair(MMSKEY_BLUE,"BLUE"));
		keymap.insert(std::make_pair(MMSKEY_CHANNEL_UP,"CHANNEL_UP"));
		keymap.insert(std::make_pair(MMSKEY_CHANNEL_DOWN,"CHANNEL_DOWN"));
		keymap.insert(std::make_pair(MMSKEY_BACK,"BACK"));
		keymap.insert(std::make_pair(MMSKEY_FORWARD,"FORWARD"));
		keymap.insert(std::make_pair(MMSKEY_FIRST,"FIRST"));
		keymap.insert(std::make_pair(MMSKEY_LAST,"LAST"));
		keymap.insert(std::make_pair(MMSKEY_VOLUME_UP,"VOLUME_UP"));
		keymap.insert(std::make_pair(MMSKEY_VOLUME_DOWN,"VOLUME_DOWN"));
		keymap.insert(std::make_pair(MMSKEY_MUTE,"MUTE"));
		keymap.insert(std::make_pair(MMSKEY_AB,"AB"));
		keymap.insert(std::make_pair(MMSKEY_PLAYPAUSE,"PLAYPAUSE"));
		keymap.insert(std::make_pair(MMSKEY_PLAY,"PLAY"));
		keymap.insert(std::make_pair(MMSKEY_STOP,"STOP"));
		keymap.insert(std::make_pair(MMSKEY_RESTART,"RESTART"));
		keymap.insert(std::make_pair(MMSKEY_SLOW,"SLOW"));
		keymap.insert(std::make_pair(MMSKEY_FAST,"FAST"));
		keymap.insert(std::make_pair(MMSKEY_RECORD,"RECORD"));
		keymap.insert(std::make_pair(MMSKEY_EJECT,"EJECT"));
		keymap.insert(std::make_pair(MMSKEY_SHUFFLE,"SHUFFLE"));
		keymap.insert(std::make_pair(MMSKEY_REWIND,"REWIND"));
		keymap.insert(std::make_pair(MMSKEY_FASTFORWARD,"FASTFORWARD"));
		keymap.insert(std::make_pair(MMSKEY_PREVIOUS,"PREVIOUS"));
		keymap.insert(std::make_pair(MMSKEY_NEXT,"NEXT"));
		keymap.insert(std::make_pair(MMSKEY_BEGIN,"BEGIN"));
		keymap.insert(std::make_pair(MMSKEY_DIGITS,"DIGITS"));
		keymap.insert(std::make_pair(MMSKEY_TEEN,"TEEN"));
		keymap.insert(std::make_pair(MMSKEY_TWEN,"TWEN"));
		keymap.insert(std::make_pair(MMSKEY_BREAK,"BREAK"));
		keymap.insert(std::make_pair(MMSKEY_EXIT,"EXIT"));
		keymap.insert(std::make_pair(MMSKEY_SETUP,"SETUP"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_LEFT_UP,"CURSOR_LEFT_UP"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_LEFT_DOWN,"CURSOR_LEFT_DOWN"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_UP_RIGHT,"CURSOR_UP_RIGHT"));
		keymap.insert(std::make_pair(MMSKEY_CURSOR_DOWN_RIGHT,"CURSOR_DOWN_RIGHT"));
		keymap.insert(std::make_pair(MMSKEY_F1,"F1"));
		keymap.insert(std::make_pair(MMSKEY_F2,"F2"));
		keymap.insert(std::make_pair(MMSKEY_F3,"F3"));
		keymap.insert(std::make_pair(MMSKEY_F4,"F4"));
		keymap.insert(std::make_pair(MMSKEY_F5,"F5"));
		keymap.insert(std::make_pair(MMSKEY_F6,"F6"));
		keymap.insert(std::make_pair(MMSKEY_F7,"F7"));
		keymap.insert(std::make_pair(MMSKEY_F8,"F8"));
		keymap.insert(std::make_pair(MMSKEY_F9,"F9"));
		keymap.insert(std::make_pair(MMSKEY_F10,"F10"));
		keymap.insert(std::make_pair(MMSKEY_F11,"F11"));
		keymap.insert(std::make_pair(MMSKEY_F12,"F12"));
		keymap.insert(std::make_pair(MMSKEY_SHIFT,"SHIFT"));
		keymap.insert(std::make_pair(MMSKEY_CONTROL,"CONTROL"));
		keymap.insert(std::make_pair(MMSKEY_ALT,"ALT"));
		keymap.insert(std::make_pair(MMSKEY_ALTGR,"ALTGR"));
		keymap.insert(std::make_pair(MMSKEY_META,"META"));
		keymap.insert(std::make_pair(MMSKEY_SUPER,"SUPER"));
		keymap.insert(std::make_pair(MMSKEY_HYPER,"HYPER"));
		keymap.insert(std::make_pair(MMSKEY_CAPS_LOCK,"CAPS_LOCK"));
		keymap.insert(std::make_pair(MMSKEY_NUM_LOCK,"NUM_LOCK"));
		keymap.insert(std::make_pair(MMSKEY_SCROLL_LOCK,"SCROLL_LOCK"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_ABOVEDOT,"DEAD_ABOVEDOT"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_ABOVERING,"DEAD_ABOVERING"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_ACUTE,"DEAD_ACUTE"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_BREVE,"DEAD_BREVE"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_CARON,"DEAD_CARON"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_CEDILLA,"DEAD_CEDILLA"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_CIRCUMFLEX,"DEAD_CIRCUMFLEX"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_DIAERESIS,"DEAD_DIAERESIS"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_DOUBLEACUTE,"DEAD_DOUBLEACUTE"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_GRAVE,"DEAD_GRAVE"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_IOTA,"DEAD_IOTA"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_MACRON,"DEAD_MACRON"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_OGONEK,"DEAD_OGONEK"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_SEMIVOICED_SOUND,"DEAD_SEMIVOICED_SOUND"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_TILDE,"DEAD_TILDE"));
		keymap.insert(std::make_pair(MMSKEY_DEAD_VOICED_SOUND,"DEAD_VOICED_SOUND"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM0,"CUSTOM0"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM1,"CUSTOM1"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM2,"CUSTOM2"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM3,"CUSTOM3"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM4,"CUSTOM4"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM5,"CUSTOM5"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM6,"CUSTOM6"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM7,"CUSTOM7"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM8,"CUSTOM8"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM9,"CUSTOM9"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM10,"CUSTOM10"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM11,"CUSTOM11"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM12,"CUSTOM12"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM13,"CUSTOM13"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM14,"CUSTOM14"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM15,"CUSTOM15"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM16,"CUSTOM16"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM17,"CUSTOM17"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM18,"CUSTOM18"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM19,"CUSTOM19"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM20,"CUSTOM20"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM21,"CUSTOM21"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM22,"CUSTOM22"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM23,"CUSTOM23"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM24,"CUSTOM24"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM25,"CUSTOM25"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM26,"CUSTOM26"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM27,"CUSTOM27"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM28,"CUSTOM28"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM29,"CUSTOM29"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM30,"CUSTOM30"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM31,"CUSTOM31"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM32,"CUSTOM32"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM33,"CUSTOM33"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM34,"CUSTOM34"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM35,"CUSTOM35"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM36,"CUSTOM36"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM37,"CUSTOM37"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM38,"CUSTOM38"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM39,"CUSTOM39"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM40,"CUSTOM40"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM41,"CUSTOM41"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM42,"CUSTOM42"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM43,"CUSTOM43"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM44,"CUSTOM44"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM45,"CUSTOM45"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM46,"CUSTOM46"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM47,"CUSTOM47"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM48,"CUSTOM48"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM49,"CUSTOM49"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM50,"CUSTOM50"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM51,"CUSTOM51"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM52,"CUSTOM52"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM53,"CUSTOM53"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM54,"CUSTOM54"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM55,"CUSTOM55"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM56,"CUSTOM56"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM57,"CUSTOM57"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM58,"CUSTOM58"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM59,"CUSTOM59"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM60,"CUSTOM60"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM61,"CUSTOM61"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM62,"CUSTOM62"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM63,"CUSTOM63"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM64,"CUSTOM64"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM65,"CUSTOM65"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM66,"CUSTOM66"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM67,"CUSTOM67"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM68,"CUSTOM68"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM69,"CUSTOM69"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM70,"CUSTOM70"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM71,"CUSTOM71"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM72,"CUSTOM72"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM73,"CUSTOM73"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM74,"CUSTOM74"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM75,"CUSTOM75"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM76,"CUSTOM76"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM77,"CUSTOM77"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM78,"CUSTOM78"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM79,"CUSTOM79"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM80,"CUSTOM80"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM81,"CUSTOM81"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM82,"CUSTOM82"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM83,"CUSTOM83"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM84,"CUSTOM84"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM85,"CUSTOM85"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM86,"CUSTOM86"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM87,"CUSTOM87"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM88,"CUSTOM88"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM89,"CUSTOM89"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM90,"CUSTOM90"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM91,"CUSTOM91"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM92,"CUSTOM92"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM93,"CUSTOM93"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM94,"CUSTOM94"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM95,"CUSTOM95"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM96,"CUSTOM96"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM97,"CUSTOM97"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM98,"CUSTOM98"));
		keymap.insert(std::make_pair(MMSKEY_CUSTOM99,"CUSTOM99"));

		keymap.insert(std::make_pair(MMSKEY_NULL,"NULL"));
	}
	if(namemap.empty()) {
		namemap.insert(std::make_pair("UNKNOWN",MMSKEY_UNKNOWN));
		namemap.insert(std::make_pair("BACKSPACE",MMSKEY_BACKSPACE));
		namemap.insert(std::make_pair("TAB",MMSKEY_TAB));
		namemap.insert(std::make_pair("RETURN",MMSKEY_RETURN));
		namemap.insert(std::make_pair("CANCEL",MMSKEY_CANCEL));
		namemap.insert(std::make_pair("ESCAPE",MMSKEY_ESCAPE));
		namemap.insert(std::make_pair("SPACE",MMSKEY_SPACE));
		namemap.insert(std::make_pair("EXCLAMATION_MARK",MMSKEY_EXCLAMATION_MARK));
		namemap.insert(std::make_pair("QUOTATION",MMSKEY_QUOTATION));
		namemap.insert(std::make_pair("NUMBER_SIGN",MMSKEY_NUMBER_SIGN));
		namemap.insert(std::make_pair("DOLLAR_SIGN",MMSKEY_DOLLAR_SIGN));
		namemap.insert(std::make_pair("PERCENT_SIGN",MMSKEY_PERCENT_SIGN));
		namemap.insert(std::make_pair("AMPERSAND",MMSKEY_AMPERSAND));
		namemap.insert(std::make_pair("APOSTROPHE",MMSKEY_APOSTROPHE));
		namemap.insert(std::make_pair("PARENTHESIS_LEFT",MMSKEY_PARENTHESIS_LEFT));
		namemap.insert(std::make_pair("PARENTHESIS_RIGHT",MMSKEY_PARENTHESIS_RIGHT));
		namemap.insert(std::make_pair("ASTERISK",MMSKEY_ASTERISK));
		namemap.insert(std::make_pair("PLUS_SIGN",MMSKEY_PLUS_SIGN));
		namemap.insert(std::make_pair("COMMA",MMSKEY_COMMA));
		namemap.insert(std::make_pair("MINUS_SIGN",MMSKEY_MINUS_SIGN));
		namemap.insert(std::make_pair("PERIOD",MMSKEY_PERIOD));
		namemap.insert(std::make_pair("SLASH",MMSKEY_SLASH));
		namemap.insert(std::make_pair("0",MMSKEY_0));
		namemap.insert(std::make_pair("1",MMSKEY_1));
		namemap.insert(std::make_pair("2",MMSKEY_2));
		namemap.insert(std::make_pair("3",MMSKEY_3));
		namemap.insert(std::make_pair("4",MMSKEY_4));
		namemap.insert(std::make_pair("5",MMSKEY_5));
		namemap.insert(std::make_pair("6",MMSKEY_6));
		namemap.insert(std::make_pair("7",MMSKEY_7));
		namemap.insert(std::make_pair("8",MMSKEY_8));
		namemap.insert(std::make_pair("9",MMSKEY_9));
		namemap.insert(std::make_pair("COLON",MMSKEY_COLON));
		namemap.insert(std::make_pair("SEMICOLON",MMSKEY_SEMICOLON));
		namemap.insert(std::make_pair("LESS_THAN_SIGN",MMSKEY_LESS_THAN_SIGN));
		namemap.insert(std::make_pair("EQUALS_SIGN",MMSKEY_EQUALS_SIGN));
		namemap.insert(std::make_pair("GREATER_THAN_SIGN",MMSKEY_GREATER_THAN_SIGN));
		namemap.insert(std::make_pair("QUESTION_MARK",MMSKEY_QUESTION_MARK));
		namemap.insert(std::make_pair("AT",MMSKEY_AT));
		namemap.insert(std::make_pair("CAPITAL_A",MMSKEY_CAPITAL_A));
		namemap.insert(std::make_pair("CAPITAL_B",MMSKEY_CAPITAL_B));
		namemap.insert(std::make_pair("CAPITAL_C",MMSKEY_CAPITAL_C));
		namemap.insert(std::make_pair("CAPITAL_D",MMSKEY_CAPITAL_D));
		namemap.insert(std::make_pair("CAPITAL_E",MMSKEY_CAPITAL_E));
		namemap.insert(std::make_pair("CAPITAL_F",MMSKEY_CAPITAL_F));
		namemap.insert(std::make_pair("CAPITAL_G",MMSKEY_CAPITAL_G));
		namemap.insert(std::make_pair("CAPITAL_H",MMSKEY_CAPITAL_H));
		namemap.insert(std::make_pair("CAPITAL_I",MMSKEY_CAPITAL_I));
		namemap.insert(std::make_pair("CAPITAL_J",MMSKEY_CAPITAL_J));
		namemap.insert(std::make_pair("CAPITAL_K",MMSKEY_CAPITAL_K));
		namemap.insert(std::make_pair("CAPITAL_L",MMSKEY_CAPITAL_L));
		namemap.insert(std::make_pair("CAPITAL_M",MMSKEY_CAPITAL_M));
		namemap.insert(std::make_pair("CAPITAL_N",MMSKEY_CAPITAL_N));
		namemap.insert(std::make_pair("CAPITAL_O",MMSKEY_CAPITAL_O));
		namemap.insert(std::make_pair("CAPITAL_P",MMSKEY_CAPITAL_P));
		namemap.insert(std::make_pair("CAPITAL_Q",MMSKEY_CAPITAL_Q));
		namemap.insert(std::make_pair("CAPITAL_R",MMSKEY_CAPITAL_R));
		namemap.insert(std::make_pair("CAPITAL_S",MMSKEY_CAPITAL_S));
		namemap.insert(std::make_pair("CAPITAL_T",MMSKEY_CAPITAL_T));
		namemap.insert(std::make_pair("CAPITAL_U",MMSKEY_CAPITAL_U));
		namemap.insert(std::make_pair("CAPITAL_V",MMSKEY_CAPITAL_V));
		namemap.insert(std::make_pair("CAPITAL_W",MMSKEY_CAPITAL_W));
		namemap.insert(std::make_pair("CAPITAL_X",MMSKEY_CAPITAL_X));
		namemap.insert(std::make_pair("CAPITAL_Y",MMSKEY_CAPITAL_Y));
		namemap.insert(std::make_pair("CAPITAL_Z",MMSKEY_CAPITAL_Z));
		namemap.insert(std::make_pair("SQUARE_BRACKET_LEFT",MMSKEY_SQUARE_BRACKET_LEFT));
		namemap.insert(std::make_pair("BACKSLASH",MMSKEY_BACKSLASH));
		namemap.insert(std::make_pair("SQUARE_BRACKET_RIGHT",MMSKEY_SQUARE_BRACKET_RIGHT));
		namemap.insert(std::make_pair("CIRCUMFLEX_ACCENT",MMSKEY_CIRCUMFLEX_ACCENT));
		namemap.insert(std::make_pair("UNDERSCORE",MMSKEY_UNDERSCORE));
		namemap.insert(std::make_pair("GRAVE_ACCENT",MMSKEY_GRAVE_ACCENT));
		namemap.insert(std::make_pair("SMALL_A",MMSKEY_SMALL_A));
		namemap.insert(std::make_pair("SMALL_B",MMSKEY_SMALL_B));
		namemap.insert(std::make_pair("SMALL_C",MMSKEY_SMALL_C));
		namemap.insert(std::make_pair("SMALL_D",MMSKEY_SMALL_D));
		namemap.insert(std::make_pair("SMALL_E",MMSKEY_SMALL_E));
		namemap.insert(std::make_pair("SMALL_F",MMSKEY_SMALL_F));
		namemap.insert(std::make_pair("SMALL_G",MMSKEY_SMALL_G));
		namemap.insert(std::make_pair("SMALL_H",MMSKEY_SMALL_H));
		namemap.insert(std::make_pair("SMALL_I",MMSKEY_SMALL_I));
		namemap.insert(std::make_pair("SMALL_J",MMSKEY_SMALL_J));
		namemap.insert(std::make_pair("SMALL_K",MMSKEY_SMALL_K));
		namemap.insert(std::make_pair("SMALL_L",MMSKEY_SMALL_L));
		namemap.insert(std::make_pair("SMALL_M",MMSKEY_SMALL_M));
		namemap.insert(std::make_pair("SMALL_N",MMSKEY_SMALL_N));
		namemap.insert(std::make_pair("SMALL_O",MMSKEY_SMALL_O));
		namemap.insert(std::make_pair("SMALL_P",MMSKEY_SMALL_P));
		namemap.insert(std::make_pair("SMALL_Q",MMSKEY_SMALL_Q));
		namemap.insert(std::make_pair("SMALL_R",MMSKEY_SMALL_R));
		namemap.insert(std::make_pair("SMALL_S",MMSKEY_SMALL_S));
		namemap.insert(std::make_pair("SMALL_T",MMSKEY_SMALL_T));
		namemap.insert(std::make_pair("SMALL_U",MMSKEY_SMALL_U));
		namemap.insert(std::make_pair("SMALL_V",MMSKEY_SMALL_V));
		namemap.insert(std::make_pair("SMALL_W",MMSKEY_SMALL_W));
		namemap.insert(std::make_pair("SMALL_X",MMSKEY_SMALL_X));
		namemap.insert(std::make_pair("SMALL_Y",MMSKEY_SMALL_Y));
		namemap.insert(std::make_pair("SMALL_Z",MMSKEY_SMALL_Z));
		namemap.insert(std::make_pair("CURLY_BRACKET_LEFT",MMSKEY_CURLY_BRACKET_LEFT));
		namemap.insert(std::make_pair("VERTICAL_BAR",MMSKEY_VERTICAL_BAR));
		namemap.insert(std::make_pair("CURLY_BRACKET_RIGHT",MMSKEY_CURLY_BRACKET_RIGHT));
		namemap.insert(std::make_pair("TILDE",MMSKEY_TILDE));
		namemap.insert(std::make_pair("DELETE",MMSKEY_DELETE));
		namemap.insert(std::make_pair("CURSOR_LEFT",MMSKEY_CURSOR_LEFT));
		namemap.insert(std::make_pair("CURSOR_RIGHT",MMSKEY_CURSOR_RIGHT));
		namemap.insert(std::make_pair("CURSOR_UP",MMSKEY_CURSOR_UP));
		namemap.insert(std::make_pair("CURSOR_DOWN",MMSKEY_CURSOR_DOWN));
		namemap.insert(std::make_pair("INSERT",MMSKEY_INSERT));
		namemap.insert(std::make_pair("HOME",MMSKEY_HOME));
		namemap.insert(std::make_pair("END",MMSKEY_END));
		namemap.insert(std::make_pair("PAGE_UP",MMSKEY_PAGE_UP));
		namemap.insert(std::make_pair("PAGE_DOWN",MMSKEY_PAGE_DOWN));
		namemap.insert(std::make_pair("PRINT",MMSKEY_PRINT));
		namemap.insert(std::make_pair("PAUSE",MMSKEY_PAUSE));
		namemap.insert(std::make_pair("OK",MMSKEY_OK));
		namemap.insert(std::make_pair("SELECT",MMSKEY_SELECT));
		namemap.insert(std::make_pair("GOTO",MMSKEY_GOTO));
		namemap.insert(std::make_pair("CLEAR",MMSKEY_CLEAR));
		namemap.insert(std::make_pair("POWER",MMSKEY_POWER));
		namemap.insert(std::make_pair("POWER2",MMSKEY_POWER2));
		namemap.insert(std::make_pair("OPTION",MMSKEY_OPTION));
		namemap.insert(std::make_pair("MENU",MMSKEY_MENU));
		namemap.insert(std::make_pair("HELP",MMSKEY_HELP));
		namemap.insert(std::make_pair("INFO",MMSKEY_INFO));
		namemap.insert(std::make_pair("TIME",MMSKEY_TIME));
		namemap.insert(std::make_pair("VENDOR",MMSKEY_VENDOR));
		namemap.insert(std::make_pair("ARCHIVE",MMSKEY_ARCHIVE));
		namemap.insert(std::make_pair("PROGRAM",MMSKEY_PROGRAM));
		namemap.insert(std::make_pair("CHANNEL",MMSKEY_CHANNEL));
		namemap.insert(std::make_pair("FAVORITES",MMSKEY_FAVORITES));
		namemap.insert(std::make_pair("EPG",MMSKEY_EPG));
		namemap.insert(std::make_pair("PVR",MMSKEY_PVR));
		namemap.insert(std::make_pair("MHP",MMSKEY_MHP));
		namemap.insert(std::make_pair("LANGUAGE",MMSKEY_LANGUAGE));
		namemap.insert(std::make_pair("TITLE",MMSKEY_TITLE));
		namemap.insert(std::make_pair("SUBTITLE",MMSKEY_SUBTITLE));
		namemap.insert(std::make_pair("ANGLE",MMSKEY_ANGLE));
		namemap.insert(std::make_pair("ZOOM",MMSKEY_ZOOM));
		namemap.insert(std::make_pair("MODE",MMSKEY_MODE));
		namemap.insert(std::make_pair("KEYBOARD",MMSKEY_KEYBOARD));
		namemap.insert(std::make_pair("PC",MMSKEY_PC));
		namemap.insert(std::make_pair("SCREEN",MMSKEY_SCREEN));
		namemap.insert(std::make_pair("TV",MMSKEY_TV));
		namemap.insert(std::make_pair("TV2",MMSKEY_TV2));
		namemap.insert(std::make_pair("VCR",MMSKEY_VCR));
		namemap.insert(std::make_pair("VCR2",MMSKEY_VCR2));
		namemap.insert(std::make_pair("SAT",MMSKEY_SAT));
		namemap.insert(std::make_pair("SAT2",MMSKEY_SAT2));
		namemap.insert(std::make_pair("CD",MMSKEY_CD));
		namemap.insert(std::make_pair("TAPE",MMSKEY_TAPE));
		namemap.insert(std::make_pair("RADIO",MMSKEY_RADIO));
		namemap.insert(std::make_pair("TUNER",MMSKEY_TUNER));
		namemap.insert(std::make_pair("PLAYER",MMSKEY_PLAYER));
		namemap.insert(std::make_pair("TEXT",MMSKEY_TEXT));
		namemap.insert(std::make_pair("DVD",MMSKEY_DVD));
		namemap.insert(std::make_pair("AUX",MMSKEY_AUX));
		namemap.insert(std::make_pair("MP3",MMSKEY_MP3));
		namemap.insert(std::make_pair("PHONE",MMSKEY_PHONE));
		namemap.insert(std::make_pair("AUDIO",MMSKEY_AUDIO));
		namemap.insert(std::make_pair("VIDEO",MMSKEY_VIDEO));
		namemap.insert(std::make_pair("INTERNET",MMSKEY_INTERNET));
		namemap.insert(std::make_pair("MAIL",MMSKEY_MAIL));
		namemap.insert(std::make_pair("NEWS",MMSKEY_NEWS));
		namemap.insert(std::make_pair("DIRECTORY",MMSKEY_DIRECTORY));
		namemap.insert(std::make_pair("LIST",MMSKEY_LIST));
		namemap.insert(std::make_pair("CALCULATOR",MMSKEY_CALCULATOR));
		namemap.insert(std::make_pair("MEMO",MMSKEY_MEMO));
		namemap.insert(std::make_pair("CALENDAR",MMSKEY_CALENDAR));
		namemap.insert(std::make_pair("EDITOR",MMSKEY_EDITOR));
		namemap.insert(std::make_pair("RED",MMSKEY_RED));
		namemap.insert(std::make_pair("GREEN",MMSKEY_GREEN));
		namemap.insert(std::make_pair("YELLOW",MMSKEY_YELLOW));
		namemap.insert(std::make_pair("BLUE",MMSKEY_BLUE));
		namemap.insert(std::make_pair("CHANNEL_UP",MMSKEY_CHANNEL_UP));
		namemap.insert(std::make_pair("CHANNEL_DOWN",MMSKEY_CHANNEL_DOWN));
		namemap.insert(std::make_pair("BACK",MMSKEY_BACK));
		namemap.insert(std::make_pair("FORWARD",MMSKEY_FORWARD));
		namemap.insert(std::make_pair("FIRST",MMSKEY_FIRST));
		namemap.insert(std::make_pair("LAST",MMSKEY_LAST));
		namemap.insert(std::make_pair("VOLUME_UP",MMSKEY_VOLUME_UP));
		namemap.insert(std::make_pair("VOLUME_DOWN",MMSKEY_VOLUME_DOWN));
		namemap.insert(std::make_pair("MUTE",MMSKEY_MUTE));
		namemap.insert(std::make_pair("AB",MMSKEY_AB));
		namemap.insert(std::make_pair("PLAYPAUSE",MMSKEY_PLAYPAUSE));
		namemap.insert(std::make_pair("PLAY",MMSKEY_PLAY));
		namemap.insert(std::make_pair("STOP",MMSKEY_STOP));
		namemap.insert(std::make_pair("RESTART",MMSKEY_RESTART));
		namemap.insert(std::make_pair("SLOW",MMSKEY_SLOW));
		namemap.insert(std::make_pair("FAST",MMSKEY_FAST));
		namemap.insert(std::make_pair("RECORD",MMSKEY_RECORD));
		namemap.insert(std::make_pair("EJECT",MMSKEY_EJECT));
		namemap.insert(std::make_pair("SHUFFLE",MMSKEY_SHUFFLE));
		namemap.insert(std::make_pair("REWIND",MMSKEY_REWIND));
		namemap.insert(std::make_pair("FASTFORWARD",MMSKEY_FASTFORWARD));
		namemap.insert(std::make_pair("PREVIOUS",MMSKEY_PREVIOUS));
		namemap.insert(std::make_pair("NEXT",MMSKEY_NEXT));
		namemap.insert(std::make_pair("BEGIN",MMSKEY_BEGIN));
		namemap.insert(std::make_pair("DIGITS",MMSKEY_DIGITS));
		namemap.insert(std::make_pair("TEEN",MMSKEY_TEEN));
		namemap.insert(std::make_pair("TWEN",MMSKEY_TWEN));
		namemap.insert(std::make_pair("BREAK",MMSKEY_BREAK));
		namemap.insert(std::make_pair("EXIT",MMSKEY_EXIT));
		namemap.insert(std::make_pair("SETUP",MMSKEY_SETUP));
		namemap.insert(std::make_pair("CURSOR_LEFT_UP",MMSKEY_CURSOR_LEFT_UP));
		namemap.insert(std::make_pair("CURSOR_LEFT_DOWN",MMSKEY_CURSOR_LEFT_DOWN));
		namemap.insert(std::make_pair("CURSOR_UP_RIGHT",MMSKEY_CURSOR_UP_RIGHT));
		namemap.insert(std::make_pair("CURSOR_DOWN_RIGHT",MMSKEY_CURSOR_DOWN_RIGHT));
		namemap.insert(std::make_pair("F1",MMSKEY_F1));
		namemap.insert(std::make_pair("F2",MMSKEY_F2));
		namemap.insert(std::make_pair("F3",MMSKEY_F3));
		namemap.insert(std::make_pair("F4",MMSKEY_F4));
		namemap.insert(std::make_pair("F5",MMSKEY_F5));
		namemap.insert(std::make_pair("F6",MMSKEY_F6));
		namemap.insert(std::make_pair("F7",MMSKEY_F7));
		namemap.insert(std::make_pair("F8",MMSKEY_F8));
		namemap.insert(std::make_pair("F9",MMSKEY_F9));
		namemap.insert(std::make_pair("F10",MMSKEY_F10));
		namemap.insert(std::make_pair("F11",MMSKEY_F11));
		namemap.insert(std::make_pair("F12",MMSKEY_F12));
		namemap.insert(std::make_pair("SHIFT",MMSKEY_SHIFT));
		namemap.insert(std::make_pair("CONTROL",MMSKEY_CONTROL));
		namemap.insert(std::make_pair("ALT",MMSKEY_ALT));
		namemap.insert(std::make_pair("ALTGR",MMSKEY_ALTGR));
		namemap.insert(std::make_pair("META",MMSKEY_META));
		namemap.insert(std::make_pair("SUPER",MMSKEY_SUPER));
		namemap.insert(std::make_pair("HYPER",MMSKEY_HYPER));
		namemap.insert(std::make_pair("CAPS_LOCK",MMSKEY_CAPS_LOCK));
		namemap.insert(std::make_pair("NUM_LOCK",MMSKEY_NUM_LOCK));
		namemap.insert(std::make_pair("SCROLL_LOCK",MMSKEY_SCROLL_LOCK));
		namemap.insert(std::make_pair("DEAD_ABOVEDOT",MMSKEY_DEAD_ABOVEDOT));
		namemap.insert(std::make_pair("DEAD_ABOVERING",MMSKEY_DEAD_ABOVERING));
		namemap.insert(std::make_pair("DEAD_ACUTE",MMSKEY_DEAD_ACUTE));
		namemap.insert(std::make_pair("DEAD_BREVE",MMSKEY_DEAD_BREVE));
		namemap.insert(std::make_pair("DEAD_CARON",MMSKEY_DEAD_CARON));
		namemap.insert(std::make_pair("DEAD_CEDILLA",MMSKEY_DEAD_CEDILLA));
		namemap.insert(std::make_pair("DEAD_CIRCUMFLEX",MMSKEY_DEAD_CIRCUMFLEX));
		namemap.insert(std::make_pair("DEAD_DIAERESIS",MMSKEY_DEAD_DIAERESIS));
		namemap.insert(std::make_pair("DEAD_DOUBLEACUTE",MMSKEY_DEAD_DOUBLEACUTE));
		namemap.insert(std::make_pair("DEAD_GRAVE",MMSKEY_DEAD_GRAVE));
		namemap.insert(std::make_pair("DEAD_IOTA",MMSKEY_DEAD_IOTA));
		namemap.insert(std::make_pair("DEAD_MACRON",MMSKEY_DEAD_MACRON));
		namemap.insert(std::make_pair("DEAD_OGONEK",MMSKEY_DEAD_OGONEK));
		namemap.insert(std::make_pair("DEAD_SEMIVOICED_SOUND",MMSKEY_DEAD_SEMIVOICED_SOUND));
		namemap.insert(std::make_pair("DEAD_TILDE",MMSKEY_DEAD_TILDE));
		namemap.insert(std::make_pair("DEAD_VOICED_SOUND",MMSKEY_DEAD_VOICED_SOUND));
		namemap.insert(std::make_pair("CUSTOM0",MMSKEY_CUSTOM0));
		namemap.insert(std::make_pair("CUSTOM1",MMSKEY_CUSTOM1));
		namemap.insert(std::make_pair("CUSTOM2",MMSKEY_CUSTOM2));
		namemap.insert(std::make_pair("CUSTOM3",MMSKEY_CUSTOM3));
		namemap.insert(std::make_pair("CUSTOM4",MMSKEY_CUSTOM4));
		namemap.insert(std::make_pair("CUSTOM5",MMSKEY_CUSTOM5));
		namemap.insert(std::make_pair("CUSTOM6",MMSKEY_CUSTOM6));
		namemap.insert(std::make_pair("CUSTOM7",MMSKEY_CUSTOM7));
		namemap.insert(std::make_pair("CUSTOM8",MMSKEY_CUSTOM8));
		namemap.insert(std::make_pair("CUSTOM9",MMSKEY_CUSTOM9));
		namemap.insert(std::make_pair("CUSTOM10",MMSKEY_CUSTOM10));
		namemap.insert(std::make_pair("CUSTOM11",MMSKEY_CUSTOM11));
		namemap.insert(std::make_pair("CUSTOM12",MMSKEY_CUSTOM12));
		namemap.insert(std::make_pair("CUSTOM13",MMSKEY_CUSTOM13));
		namemap.insert(std::make_pair("CUSTOM14",MMSKEY_CUSTOM14));
		namemap.insert(std::make_pair("CUSTOM15",MMSKEY_CUSTOM15));
		namemap.insert(std::make_pair("CUSTOM16",MMSKEY_CUSTOM16));
		namemap.insert(std::make_pair("CUSTOM17",MMSKEY_CUSTOM17));
		namemap.insert(std::make_pair("CUSTOM18",MMSKEY_CUSTOM18));
		namemap.insert(std::make_pair("CUSTOM19",MMSKEY_CUSTOM19));
		namemap.insert(std::make_pair("CUSTOM20",MMSKEY_CUSTOM20));
		namemap.insert(std::make_pair("CUSTOM21",MMSKEY_CUSTOM21));
		namemap.insert(std::make_pair("CUSTOM22",MMSKEY_CUSTOM22));
		namemap.insert(std::make_pair("CUSTOM23",MMSKEY_CUSTOM23));
		namemap.insert(std::make_pair("CUSTOM24",MMSKEY_CUSTOM24));
		namemap.insert(std::make_pair("CUSTOM25",MMSKEY_CUSTOM25));
		namemap.insert(std::make_pair("CUSTOM26",MMSKEY_CUSTOM26));
		namemap.insert(std::make_pair("CUSTOM27",MMSKEY_CUSTOM27));
		namemap.insert(std::make_pair("CUSTOM28",MMSKEY_CUSTOM28));
		namemap.insert(std::make_pair("CUSTOM29",MMSKEY_CUSTOM29));
		namemap.insert(std::make_pair("CUSTOM30",MMSKEY_CUSTOM30));
		namemap.insert(std::make_pair("CUSTOM31",MMSKEY_CUSTOM31));
		namemap.insert(std::make_pair("CUSTOM32",MMSKEY_CUSTOM32));
		namemap.insert(std::make_pair("CUSTOM33",MMSKEY_CUSTOM33));
		namemap.insert(std::make_pair("CUSTOM34",MMSKEY_CUSTOM34));
		namemap.insert(std::make_pair("CUSTOM35",MMSKEY_CUSTOM35));
		namemap.insert(std::make_pair("CUSTOM36",MMSKEY_CUSTOM36));
		namemap.insert(std::make_pair("CUSTOM37",MMSKEY_CUSTOM37));
		namemap.insert(std::make_pair("CUSTOM38",MMSKEY_CUSTOM38));
		namemap.insert(std::make_pair("CUSTOM39",MMSKEY_CUSTOM39));
		namemap.insert(std::make_pair("CUSTOM40",MMSKEY_CUSTOM40));
		namemap.insert(std::make_pair("CUSTOM41",MMSKEY_CUSTOM41));
		namemap.insert(std::make_pair("CUSTOM42",MMSKEY_CUSTOM42));
		namemap.insert(std::make_pair("CUSTOM43",MMSKEY_CUSTOM43));
		namemap.insert(std::make_pair("CUSTOM44",MMSKEY_CUSTOM44));
		namemap.insert(std::make_pair("CUSTOM45",MMSKEY_CUSTOM45));
		namemap.insert(std::make_pair("CUSTOM46",MMSKEY_CUSTOM46));
		namemap.insert(std::make_pair("CUSTOM47",MMSKEY_CUSTOM47));
		namemap.insert(std::make_pair("CUSTOM48",MMSKEY_CUSTOM48));
		namemap.insert(std::make_pair("CUSTOM49",MMSKEY_CUSTOM49));
		namemap.insert(std::make_pair("CUSTOM50",MMSKEY_CUSTOM50));
		namemap.insert(std::make_pair("CUSTOM51",MMSKEY_CUSTOM51));
		namemap.insert(std::make_pair("CUSTOM52",MMSKEY_CUSTOM52));
		namemap.insert(std::make_pair("CUSTOM53",MMSKEY_CUSTOM53));
		namemap.insert(std::make_pair("CUSTOM54",MMSKEY_CUSTOM54));
		namemap.insert(std::make_pair("CUSTOM55",MMSKEY_CUSTOM55));
		namemap.insert(std::make_pair("CUSTOM56",MMSKEY_CUSTOM56));
		namemap.insert(std::make_pair("CUSTOM57",MMSKEY_CUSTOM57));
		namemap.insert(std::make_pair("CUSTOM58",MMSKEY_CUSTOM58));
		namemap.insert(std::make_pair("CUSTOM59",MMSKEY_CUSTOM59));
		namemap.insert(std::make_pair("CUSTOM60",MMSKEY_CUSTOM60));
		namemap.insert(std::make_pair("CUSTOM61",MMSKEY_CUSTOM61));
		namemap.insert(std::make_pair("CUSTOM62",MMSKEY_CUSTOM62));
		namemap.insert(std::make_pair("CUSTOM63",MMSKEY_CUSTOM63));
		namemap.insert(std::make_pair("CUSTOM64",MMSKEY_CUSTOM64));
		namemap.insert(std::make_pair("CUSTOM65",MMSKEY_CUSTOM65));
		namemap.insert(std::make_pair("CUSTOM66",MMSKEY_CUSTOM66));
		namemap.insert(std::make_pair("CUSTOM67",MMSKEY_CUSTOM67));
		namemap.insert(std::make_pair("CUSTOM68",MMSKEY_CUSTOM68));
		namemap.insert(std::make_pair("CUSTOM69",MMSKEY_CUSTOM69));
		namemap.insert(std::make_pair("CUSTOM70",MMSKEY_CUSTOM70));
		namemap.insert(std::make_pair("CUSTOM71",MMSKEY_CUSTOM71));
		namemap.insert(std::make_pair("CUSTOM72",MMSKEY_CUSTOM72));
		namemap.insert(std::make_pair("CUSTOM73",MMSKEY_CUSTOM73));
		namemap.insert(std::make_pair("CUSTOM74",MMSKEY_CUSTOM74));
		namemap.insert(std::make_pair("CUSTOM75",MMSKEY_CUSTOM75));
		namemap.insert(std::make_pair("CUSTOM76",MMSKEY_CUSTOM76));
		namemap.insert(std::make_pair("CUSTOM77",MMSKEY_CUSTOM77));
		namemap.insert(std::make_pair("CUSTOM78",MMSKEY_CUSTOM78));
		namemap.insert(std::make_pair("CUSTOM79",MMSKEY_CUSTOM79));
		namemap.insert(std::make_pair("CUSTOM80",MMSKEY_CUSTOM80));
		namemap.insert(std::make_pair("CUSTOM81",MMSKEY_CUSTOM81));
		namemap.insert(std::make_pair("CUSTOM82",MMSKEY_CUSTOM82));
		namemap.insert(std::make_pair("CUSTOM83",MMSKEY_CUSTOM83));
		namemap.insert(std::make_pair("CUSTOM84",MMSKEY_CUSTOM84));
		namemap.insert(std::make_pair("CUSTOM85",MMSKEY_CUSTOM85));
		namemap.insert(std::make_pair("CUSTOM86",MMSKEY_CUSTOM86));
		namemap.insert(std::make_pair("CUSTOM87",MMSKEY_CUSTOM87));
		namemap.insert(std::make_pair("CUSTOM88",MMSKEY_CUSTOM88));
		namemap.insert(std::make_pair("CUSTOM89",MMSKEY_CUSTOM89));
		namemap.insert(std::make_pair("CUSTOM90",MMSKEY_CUSTOM90));
		namemap.insert(std::make_pair("CUSTOM91",MMSKEY_CUSTOM91));
		namemap.insert(std::make_pair("CUSTOM92",MMSKEY_CUSTOM92));
		namemap.insert(std::make_pair("CUSTOM93",MMSKEY_CUSTOM93));
		namemap.insert(std::make_pair("CUSTOM94",MMSKEY_CUSTOM94));
		namemap.insert(std::make_pair("CUSTOM95",MMSKEY_CUSTOM95));
		namemap.insert(std::make_pair("CUSTOM96",MMSKEY_CUSTOM96));
		namemap.insert(std::make_pair("CUSTOM97",MMSKEY_CUSTOM97));
		namemap.insert(std::make_pair("CUSTOM98",MMSKEY_CUSTOM98));
		namemap.insert(std::make_pair("CUSTOM99",MMSKEY_CUSTOM99));
		namemap.insert(std::make_pair("NULL",MMSKEY_NULL));
	}
}

MMSKeySymbol MMSKeyMap::operator[](const char* val) {
	std::map<std::string,MMSKeySymbol>::iterator it;
	it = namemap.find(val);
	if(it!=namemap.end()) {
		return it->second;
	} else
		return MMSKEY_UNKNOWN;
}

MMSKeySymbol MMSKeyMap::operator[](std::string &val) {
	std::map<std::string,MMSKeySymbol>::iterator it;
	it = namemap.find(val);
	if(it!=namemap.end()) {
		return it->second;
	} else
		return MMSKEY_UNKNOWN;
}

std::string  &MMSKeyMap::operator[](MMSKeySymbol key) {
	std::map<MMSKeySymbol, std::string>::iterator it;
	it = keymap.find(key);
	if(it!=keymap.end()) {
		return it->second;
	} else {
		return keymap.find(MMSKEY_UNKNOWN)->second;
	}
}
